
/* 
Ansteuerung eines Wandel & Goltermann 4-Klang Kinogong ( Zeiss Ikon Klangfilm Proj)


4 klang gong

v1.0 10.02.2017 JH
v1.1 25.02.2018 JH modifications input switches
*/

// constants
// input button A0 - A3
const int button1Pin = A0;
const int button2Pin = A1;
const int button3Pin = A2;
const int button4Pin = A3;

int button1State = 0;
int button2State = 0;
int button3State = 0;
int button4State = 0;

// output to relais 
const int Rel1Pin = 5;
const int Rel2Pin = 6;
const int Rel3Pin = 7;
const int Rel4Pin = 8;

const int Rel5Pin = 9;	// poweron Amplifier

// delay between each tone -1.16sec (in ms)
const long toneDelay = 1160;

// poweron time magnet coil in ms
const int RelOn = 500;

//poweron delay Amplifier in ms
const int ampOn = 200;

// power off delay Amplifier in ms -12s
const long ampDelay = 14000;
unsigned long previousMillis = 0;
unsigned long startMillis = 0;



void setup()
{
	  // initialize serial communications at 9600 bps:
  Serial.begin(9600);
	// set pinmode
	pinMode(button1Pin, INPUT);
	pinMode(button2Pin, INPUT);
	pinMode(button3Pin, INPUT);
	pinMode(button4Pin, INPUT);
	
	pinMode(Rel1Pin, OUTPUT);
	pinMode(Rel2Pin, OUTPUT);
	pinMode(Rel3Pin, OUTPUT);
	pinMode(Rel4Pin, OUTPUT);
	pinMode(Rel5Pin, OUTPUT);
	
	// set output to HIGH -- LOW = Relais(1-4) ON
	digitalWrite(Rel1Pin, HIGH);
	digitalWrite(Rel2Pin, HIGH);
	digitalWrite(Rel3Pin, HIGH);
	digitalWrite(Rel4Pin, HIGH);
	digitalWrite(Rel5Pin, LOW);		

  
}

void loop()
{
	
	// read the buttons
	button1State = digitalRead(button1Pin);
	button2State = digitalRead(button2Pin);
	button3State = digitalRead(button3Pin);
	button4State = digitalRead(button4Pin);
 
//Serial.print("Button 1:");
//Serial.println(button1State);
//Serial.print("Button 2:");
//Serial.println(button2State);
//Serial.print("Button 3:");
//Serial.println(button3State);
//Serial.print("Button 4:");
//Serial.println(button4State);
  
	// do something
	
	// 1 tone
	if (button1State == HIGH) {
		digitalWrite(Rel5Pin, HIGH);
		delay(ampOn);

		digitalWrite(Rel1Pin, LOW);
		delay(RelOn);
		digitalWrite(Rel1Pin, HIGH);
    startMillis = millis();
	}
	
	// 2 tone
	if (button2State == HIGH) {
		digitalWrite(Rel5Pin, HIGH);
		delay(ampOn);

		digitalWrite(Rel1Pin, LOW);
		delay(RelOn);
		digitalWrite(Rel1Pin, HIGH);
		delay(toneDelay);
		digitalWrite(Rel2Pin, LOW);
		delay(RelOn);
		digitalWrite(Rel2Pin, HIGH);
	  startMillis = millis();
	}
	
	// 3 tone
	if (button3State == HIGH) {
		digitalWrite(Rel5Pin, HIGH);
		delay(ampOn);

		digitalWrite(Rel1Pin, LOW);
		delay(RelOn);
		digitalWrite(Rel1Pin, HIGH);
		delay(toneDelay);
		digitalWrite(Rel2Pin, LOW);
		delay(RelOn);
		digitalWrite(Rel2Pin, HIGH);
		delay(toneDelay);
		digitalWrite(Rel3Pin, LOW);
		delay(RelOn);
		digitalWrite(Rel3Pin, HIGH);
	  startMillis = millis();
	}
	
	// 4 tone
	if (button4State == HIGH) {
		digitalWrite(Rel5Pin, HIGH);
		delay(ampOn);
		
		digitalWrite(Rel1Pin, LOW);
		delay(RelOn);
		digitalWrite(Rel1Pin, HIGH);
		delay(toneDelay);
		digitalWrite(Rel2Pin, LOW);
		delay(RelOn);
		digitalWrite(Rel2Pin, HIGH);
		delay(toneDelay);
		digitalWrite(Rel3Pin, LOW);
		delay(RelOn);
		digitalWrite(Rel3Pin, HIGH);
		delay(toneDelay);
		digitalWrite(Rel4Pin, LOW);
		delay(RelOn);
		digitalWrite(Rel4Pin, HIGH);
    startMillis = millis();
	}
	
	
	// check millis for Amp Relais
	unsigned long currMillis = millis();
	if (currMillis - startMillis >= ampDelay) {
		digitalWrite(Rel5Pin, LOW);		
	}
	
	
}
